package com.barrelsofdata.examples.beam.streaming.sensor.function;

import com.barrelsofdata.examples.beam.streaming.sensor.model.RawEvent;
import org.apache.beam.sdk.transforms.SimpleFunction;
import org.joda.time.Instant;

/**
 * Extracts timestamp of {@link RawEvent} through the {@link com.barrelsofdata.examples.beam.streaming.sensor.model.Data} object
 */
public class ExtractTimestamp extends SimpleFunction<RawEvent, Instant> {
    private ExtractTimestamp(){}

    @Override
    public Instant apply(RawEvent input) {
        return Instant.ofEpochMilli(input.data().ts());
    }

    public static ExtractTimestamp of() {
        return new ExtractTimestamp();
    }
}
