package com.barrelsofdata.examples.beam.streaming.sensor.testutils;

import com.barrelsofdata.examples.beam.streaming.sensor.model.Data;
import com.barrelsofdata.examples.beam.streaming.sensor.model.RawEvent;
import org.joda.time.Instant;

import java.util.ArrayList;
import java.util.stream.IntStream;

public class RawEventsGenerator {
    private RawEventsGenerator() {}

    public static RawEvent generateOne() {
        return generate("testId", "2023-03-01T10:00:00.000Z", 0L, 10.0, 0.0, 1).get(0);
    }

    public static ArrayList<RawEvent> generate(String id, String timestampStart, Long timestampStepsSeconds, Double valueStart, Double valueSteps, int count) {
        Instant ts = new Instant(timestampStart);

        return new ArrayList<>(IntStream.range(0, count).boxed()
                .map(i -> {
                    Data data = new Data(ts.getMillis() + (timestampStepsSeconds * 1000 * i), valueStart + (valueSteps * i));
                    return new RawEvent(id, data);
                })
                .toList());
    }
}
